<template>
    <h1>Ortho Management</h1>
    <p>Vous pouvez créer des comptes orthophonistes ou supprimer des comptes. Vous pouvez également promouvoir des orthophonistes pour leurs donner la possibilité de créer des comptes.</p>
    <CreateOrthoAccount/>

    <InputText
          class="mt-6"
          type="text"
          v-model="search"
          placeholder="Chercher ortho"
        />

    <p v-if="filteredOrtho.length == 0">Aucun compte ortho n'est trouvé</p>
    <OrderList class="mt-4" v-model="filteredOrtho" dataKey="id">
      <template #item="ortho">
        <div class="patient-item">
            <div class="image-container">
              <Avatar icon="pi pi-user" class="mr-2" size="xlarge" />
            </div>
            <div class="patient-list-detail">
              <h5 style="margin: 5px 0px">
                {{ ortho.item.nom }} {{ ortho.item.prenom }}
              </h5>
              <p class="patient-niveau" style="margin: 0px 0px 2px 0px">{{ ortho.item.email }}</p>
              <p class="patient-niveau" style="margin: 0">Grade: <span style="font-weight: 600">{{ ortho.item.grade }}</span></p>
            </div>
            <Button label="Promouvoir" :loading="loadPromote" class="mr-2" @click="promoteOrtho(ortho.item.id)" :disabled="ortho.item.grade == 0" v-if="ortho.item.id != $store.state.user.id && ortho.item.grade == 1"/>
            <Button label="Rétrograder" :loading="loadPromote" class="mr-2" @click="retroOrtho(ortho.item.id)" v-if="ortho.item.id != $store.state.user.id && ortho.item.grade == 2 || ortho.item.id != $store.state.user.id && ortho.item.grade == 3"/>
            <Button class="p-button-danger" v-if="ortho.item.grade < $store.state.user.grade" @click="removeOrthoId = ortho.item.id; removeOrtho = true" label="Supprimer"/>
          </div>
      </template>
    </OrderList>

    <Dialog v-model:visible="removeOrtho">
          <template #header>
          <h3 class="warning">Supprimer le compte</h3>
          </template>

          <p>Vous êtes sur le point de supprimer définitivement ce compte</p>
          <p>Pour valider la suppression, veuillez cliquer sur "Supprimer"</p>

          <template #footer>
          <Button
              :loading="loadRemove"
              label="Supprimer"
              class="p-button-danger"
              @click="deleteOrtho(removeOrthoId)"
          />
          </template>
        </Dialog>
</template>

<script>
import axios from "axios"
import OrderList from "primevue/orderlist";
import Dialog from "primevue/dialog"
import Avatar from 'primevue/avatar'
import Button from 'primevue/button'
import InputText from 'primevue/inputtext'
import CreateOrthoAccount from "@/components/CreateOrthoAccount"

export default {
    name: 'OrthoView',
    components: {
        InputText,
        OrderList,
        Avatar,
        Button,
        Dialog,
        CreateOrthoAccount
    },
    data() {
        return {
          loadRemove: false,
          removeOrtho: false,
          loadPromote: false,
          removeOrthoId: "",
            orthos: [],
            search: ""
        }
    },
    created() {
        if (!this.$store.state.user.isLoggedIn || this.$store.state.user.grade == 1) {
            this.$router.push('/')
        } else {
            this.initPage();
        }
    },
    methods: {
      async retroOrtho(id) {
        this.loadPromote = true
        await axios.post("/orthophonistes/promote?idOrtho=" + id + "&promote=" + 1).then(res => {
          this.$store.commit('promoteOrtho', {id: id, grade: 1})
          this.loadPromote = false
        }).catch (err => {
            console.log(err)
            this.loadPromote = false
        })
      },
      async promoteOrtho(id) {
        this.loadPromote = true
        let roleChange = 2
        if (this.$store.state.user.grade == 5) {
          roleChange = 3
        }
        await axios.post("/orthophonistes/promote?idOrtho=" + id + "&promote=" + roleChange).then(res => {
          this.$store.commit('promoteOrtho', {id: id, grade: roleChange})
          this.loadPromote = false
            //this.$store.commit("removeOrtho", {id: id})
        }).catch (err => {
            console.log(err)
            this.loadPromote = false
        })
      },
        async deleteOrtho(id) {
          this.loadRemove = true
            await axios.delete("/orthophonistes/remove?id_ortho=" + id).then(res => {
                this.loadRemove = false
                this.removeOrtho = false
                this.$store.commit("removeOrtho", {id: id})
            }).catch (err => {
              this.loadRemove = false
                console.log(err)
            })
        },
        async initPage() {
            await axios.get('/orthophonistes').then(res => {
                this.$store.commit("importOrtho", {ortho: res.data})
            }).catch (err => {
                this.$router.push('/')
            })
        }
    },
    computed: {
    filteredOrtho() {
      let filteredOrtho = Object.values(this.$store.state.ortho);
      if (!this.search == "" && this.search) {
        filteredOrtho = filteredOrtho.filter((item) => {
          return (
            item.nom.toUpperCase().includes(this.search.toUpperCase()) ||
            item.prenom.toUpperCase().includes(this.search.toUpperCase()) ||
            item.email.includes(this.search)
          );
        });
      }
      return filteredOrtho;
    },
  }
}
</script>

<style lang="scss" scoped>
.patient-item {
  display: flex;
  align-items: center;
  padding: 0.5rem;
  width: 100%;
  text-align: left !important;

  .patient-list-detail {
    flex: 1 1 0;
  }

  .patient-niveau-icon {
    margin-right: 0.5rem;
    font-size: 0.875rem;
  }

  .patient-niveau {
    line-height: 1;
    font-size: 0.875rem;
  }
}

@media screen and (max-width: 576px) {
  .patient-item {
    flex-wrap: wrap;
    text-align: center !important;

    .image-container {
      width: 100%;
      text-align: center;
    }
  }
}

a {
  text-decoration: none;
  color: inherit;
}
</style>